#include <mylib.h>

int
log2nbits(unsigned int a, int nbits)
{
	int i;
	int b;

	b = (nbits + 1) / 2;
	i = 0;
	while (b) {
		i = (i << 1);
		if (a >= (1 << b)) {
			a /= (1 << b);
			i = i | 1;
		} else
			a &= (1 << b) - 1;
		b /= 2;
	}
	return i;
}
 
int
ceillog2nbits(unsigned int a, int nbits)
{
	int r;

	r = log2nbits(a, nbits);
	if (a == (1 << r))
		r--;

	return r;
}

#define INT_BITS        (sizeof(int) * 8)
int
log2(unsigned int a)
{
	return log2nbits(a, INT_BITS);
}

int
ceillog2(unsigned int a)
{
	return ceillog2nbits(a, INT_BITS);
}
