#include <mylib.h>
#include <mylib_regression.h>

#include <limits.h>

int
regress_log2(void)
{
	unsigned int i;

	for (i = 0; i < 8 * sizeof i; i++)
		if (log2(1 << i) != i)
			return i;

	for (i = 0; i < 8 * sizeof i; i++)
		if (log2((1 << i) | (1 << 0)) != i)
			return i + 8 * sizeof i;

	return 0;
}

int
cregress_log2(void)
{
	unsigned int i, j;
	for (i = 0; i < 8 * sizeof i; i++)
		for (j = 0; j < (1 << i); j++)
			if (log2((1 << i) + j) != i)
				return (1 << i) + j;

/*
	l2 = logf(2);
	for (i = 1; i < INT_MAX; i++) {
		if ((float)log2(i) != floorf(logf(i) / l2))
			return i;
	}
*/
	return 0;
}

int
regress_ceillog2(void)
{
	unsigned int i;

	for (i = 0; i < 8 * sizeof i; i++)
		if (ceillog2(1 << i) != i)
			return i;

	for (i = 1; i < 8 * sizeof i; i++)
		if (ceillog2((1 << i) | (1 << 0)) != i + 1)
			return i + 8 * sizeof i;

	return 0;
}

int
cregress_ceillog2(void)
{
	unsigned int i, j;

	for (i = 0; i < 8 * sizeof i; i++) {
		if (ceillog2(1 << i) != i)
			return 1 << i;
		for (j = 1; j < (1 << i); j++)
			if (ceillog2((1 << i) + j) != i + 1)
				return (1 << i) + j;
	}

/*
	l2 = logf(2);
	for (i = 1; i < UINT_MAX; i++) {
		if ((float)log2(i) != floorf(logf(i) / l2))
			return i;
	}
*/
	return 0;
}

int
regress_firstclearbit(void)
{
	unsigned int i;

	for (i = 0; i < 8 * sizeof i; i++)
		if (firstclearbit(UINT_MAX - (1 << i)) != i)
			return i;

	return 0;
}
